# qthing

## Get started
* Install the [ESP32 Toolchain](https://esp-idf.readthedocs.io/) and add it to your PATH
* Clone this project
* `git submodule update --init --recursive`
* Create `environments/<my_environment>.h` (see/copy the example file)
* Create `devices/<my_device>` directory (see/copy the example device)
* Run `./set-environment <my_environment>` (or `./set-environment <path_to_environment_file.h>`) to set a target environment
* Run `./set-device <my_device>` (or `./set_device <path_to_device_directory>`) to set a target device
* Run `./make flash` (or `./make flash monitor`) to build and flash your device

## esp-idf notes
This project includes the esp-idf as a submodule. Use the included script (`./make`) to invoke the toolchain or set your `IDF_PATH` to the projects `esp-idf` directory to avoid version conflicts.

## Disclaimer
The API is not stable
